<!---
	Elliott Sprehn (elliott [at] teratech [dot] com)

	Simple API for interacting with the CFHtmlHead functionality. These use 
	internal CF engine methods, private variables and private functions so 
	don't be surprised if they don't work on newer versions of CF.
	
	Tested to work with: MX 6.1, 7.0.2
	
	Date: June 12th 2007
	
	See: http://www.bennadel.com/index.cfm?dax=blog:758.view
--->
<cfscript>

/** 
 * Just like cfhtmlhead.
 *
 * @param text string What to write.
 */
function writeCFHtmlHead( text ) {

	/*
		<cfhtmlhead> is actually just a wrapper around this call.
	
		<cfhtmlhead text="<meta foo='bar'>"> would be the same thing.
	*/
	getPageContext().getOut().writeHeader( text );
}

/**
 * Reset the buffer for cfhtmlhead content.
 */
function resetCFHtmlHead() {

	/*
		Note we could just call reset() on the buffer itself using reflection 
		to get the headerBuffer instance method like getCFHtmlHeadContent, 
		but I figure it's probably a much better idea to let the object clear
		it's own buffer instead of reaching inside.
	*/

	var out = getPageContext().getOut();
	/*
		This method reinitializes the buffer.
	*/
	var method = out.getClass().getDeclaredMethod("initHeaderBuffer",arrayNew(1));
	method.setAccessible(true);
	method.invoke(out,arrayNew(1));
}

/**
 * Get the buffer for the cfhtmlhead content.
 *
 * @return String The content to be written to the html head on flush().
 */
function getCFHtmlHeadContent() {

	var out = getPageContext().getOut();
	/* 
		There's no method on the coldfusion.runtime.NeoJspWriter to get the
		headerBuffer used by cfhtmlhead so we need to use reflection to get it.
	*/
	var field = out.getClass().getDeclaredField("headerBuffer");	
	var buffer = 0;
	field.setAccessible(true);
	buffer = field.get(out);
	/* The get might return null */
	if( isDefined("buffer") ) return buffer.toString();
	return "";
}
</cfscript>