<!--- ColdFusion SQL Type:

API:

	function Sql SqlNew(...properties);
	function void SqlSetParam( Sql sql, Numeric position, String cfsqltype, String value );
	function void SqlSetProperty( Sql sql, String property, String value );
	function Array<Struct<String>> SqlGetParams( Sql sql );
	function Query SqlExecute( Sql sql );

Note: This code does NOT work on coldfusion 8. Use the native query cache with params instead. :)
--->

<!--- Sql Type, allows programatic cfquery with safe paramed values --->
<cffunction name="SqlNew" returntype="any" output="false">
	<cfset var sql = structNew()>
	<cfset var QueryTag = createObject("java","coldfusion.tagext.sql.QueryTag").init()>
	<cfset var QueryParamTag = createObject("java","coldfusion.tagext.sql.QueryParamTag").init()>
	<cfset var getSqlImpl = "">
	<cfset var SqlImpl = "">
	<cfset var methods = "">
	<cfset var method = "">
	
	<cfset getSqlImpl = QueryTag.getClass().getDeclaredMethod("getSqlImpl",arrayNew(1))>
	<cfset getSqlImpl.setAccessible(true)>
	<cfset SqlImpl = getSqlImpl.invoke(QueryTag,arrayNew(1))>

	<!---
		getting the method "setInParam" with getDeclaredMethod() proved 
		VERY hard, bad CF type resolution!
	--->
	<cfset methods = SqlImpl.getClass().getDeclaredMethods()>
	
	<!--- CF6: 20, CF7: 24 --->
	
	<cfif methods[20].getName() eq "setInParam" and arrayLen(methods[20].getParameterTypes()) eq 5>

		<cfset method = methods[20]>

	<cfelseif methods[24].getName() eq "setInParam" and arrayLen(methods[24].getParameterTypes()) eq 5>
		
		<cfset method = methods[24]>
	
	<cfelse>
		<cfset method = false>
		<cfloop from="1" to="#arrayLen(methods)#" index="i">
			<cfif methods[i].getName() eq "setInParam" and arrayLen(methods[i].getParameterTypes()) gte 6>
				<cfset method = methods[i]>
				<cfbreak>
			</cfif>
		</cfloop>
		<cfif not isObject(method)>
			<cfreturn false>
		</cfif>
	</cfif>
	
	<cfset sql.methods.setInParam = method>
	<cfset sql.objects.SqlImpl = SqlImpl>
	<cfset sql.objects.QueryTag = QueryTag>
	<cfset sql.objects.QueryParamTag = QueryParamTag>
	<cfset sql.properties = structNew()>

	<cfreturn sql>
</cffunction>

<cffunction name="SqlSetParam" returntype="void" output="false">
	<cfargument name="sql" type="any" required="true">
	<cfargument name="position" type="numeric" required="true">
	<cfargument name="cfsqltype" type="string" required="true">
	<cfargument name="value" type="any" required="true">
	<cfargument name="null" type="boolean" required="false" default="false">
	<cfargument name="scale" type="numeric" required="false" default="0">
	
	<cfset var args = arrayNew(1)>
			
	<cfset sql.objects.QueryParamTag.setCFSqlType(arguments.cfsqltype)>
			
	<cfset args[1] = javaCast("int",arguments.position)>

	<cfif not arguments.null>
		<cfset args[2] = arguments.value>
	</cfif>

	<!--- setInParam(int, java.lang.Object, int, int, java.lang.String, java.lang.String) --->

	<cfset args[3] = javaCast("int",sql.objects.QueryParamTag.getCfSqlType())>
	<cfset args[4] = javaCast("int",arguments.scale)>
	<cfset args[5] = arguments.cfsqltype>
	
	<cfif listFirst(server.coldfusion.productVersion) gte 8>
		<cfset args[6] = "">
	</cfif>
	
	<cfset sql.methods.setInParam.invoke(sql.objects.SqlImpl,args)>
</cffunction>

<!--- 
	Ignores username and password for caching, probably not so great!
--->
<cffunction name="SqlExecute" returntype="any" output="false">
	<cfargument name="sql" type="any" required="true">
	
	<cfset var result = "">
	<cfset var QueryTag = sql.objects.QueryTag>
	<cfset var datasource = QueryTag.getDatasource()>		
	<cfset var stmt = QueryTag.getSql()>
	<cfset var params = SqlGetParams( sql )>
	<cfset var datasourceService = createObject("java","coldfusion.server.ServiceFactory").getDatasourceService()>
	<cfset var i = "">
	<cfset var key = "">
	<cfset var cachedQuery = "">
	<cfset var error = "">
	<cfset var properties = sql.properties>
	<cfset var cachedWithin = "">
	<cfset var cachedAfter = "">
			
	<!--- throw a database error if the sql body is empty --->		
	<cfif not isDefined("stmt") or not len(stmt)>
		<cfset error = createObject("java","coldfusion.tagext.lang.ThrowTag").init()>
		<cfset error.setPageContext(getPageContext())>
		<cfset error.setObject(createObject("java","java.sql.SQLException").init("Empty SQL Statement"))>
		<cfset error.doStartTag()>
	</cfif>
					
	<cfset QueryTag.setPageContext(getPageContext())>
	<cfset QueryTag.setName("result")>
	
	<!--- simple uncached query case. --->
	<cfif not arrayLen(params)>
					
		<cfif structKeyExists( properties, "cachedWithin")>
			<cfset QueryTag.setCachedWithin( properties.cachedWithin )>
		</cfif>
		
		<cfif structKeyExists( properties, "cachedAfter")>
			<cfset QueryTag.setCachedAfter( properties.cachedAfter )>
		</cfif>
		
		<cfset QueryTag.doStartTag()>
		<cfset QueryTag.doEndTag()>
		
		<cfreturn result>
	</cfif>
	
	<cfif structKeyExists( properties, "cachedWithin")>
		<cfset cachedWithin = properties.cachedWithin>
	</cfif>
	
	<cfif structKeyExists( properties, "cachedAfter")>
		<cfset cachedAfter = properties.cachedAfter>
	</cfif>
	
	<cfif not isDefined("datasource")>
		<cfset key = "null">
		<cfset datasource = "null">
	<cfelse>
		<cfset key = datasource>
	</cfif>
	
	<cfset key = trim(stmt) & "result" & "//params:">
	
	<cfloop from="1" to="#arrayLen(params)#" index="i">
		<cfset key = key & chr(1) & "type='" & params[i].cfsqltype & "' value='" & params[i].value & "' null='" & params[i].null & "'">
	</cfloop>
	
	<!--- 			
		coldfusion.sql.QueryDetails( 
			java.lang.String,java.lang.String,java.lang.String, java.lang.String, java.lang.String, coldfusion.sql.ParameterList
		)

		guess: name, username, password, dsname, sql, paramList ???
	--->
	
	<cfif listFirst(server.coldfusion.productVersion) gte 8>
		<cfset key = createObject("java","coldfusion.sql.QueryDetails")
			.init("result","","",datasource,stmt,sql.objects.sqlImpl.getParamList())>
	</cfif>
	
	<cfset result = datasourceService.getCachedQuery(key)>
	<cfif isDefined("result") and isStruct(result)>
		
		<cfif len(cachedWithin)>
			<cfif result.timeCreated lte now()+cachedWithin>
				<cfreturn duplicate(result.query)>
			</cfif>
		</cfif>
		
		<!--- This doesn't work quite right, we won't expire every day --->
		<cfif len(cachedAfter)>
			<cfif result.timeCreated gte cachedAfter>
				<cfreturn duplicate(result.query)>
			</cfif>
		</cfif>
	</cfif>
	
	<cfset cachedQuery = structNew()>
	<cfset cachedQuery.timeCreated = now()>
			
	<!--- Execute Tag --->
	<cfset QueryTag.doStartTag()>
	<cfset QueryTag.doEndTag()>
		
	<!--- cached the query --->
	<cfif len(cachedWithin) or len(cachedAfter)>
		<cfset cachedQuery.query = result>
		<cfset datasourceService.setCachedQuery(key,cachedQuery)>
	</cfif>
	
	<cfreturn duplicate(result)>
</cffunction>

<cffunction name="SqlGetParam" returntype="any" output="false">
	<cfargument name="sql" type="any" required="true">
	<cfargument name="position" type="numeric" required="true">

	<cfset var params = SqlGetParams(sql)>
	<cfreturn params[position]>
</cffunction>

<cffunction name="SqlGetParams" returntype="any" output="false">
	<cfargument name="sql" type="any" required="true">
	
	<cfset var args = arrayNew(1)>
	<cfset var params = sql.objects.SqlImpl.getParamList()>
	<cfset var param = "">
	<cfset var result = arrayNew(1)>
	<cfset var i = "">
	
	<cfif isDefined("params")>
		<cfset params = params.getAllParameters()>
	<cfelse>
		<cfreturn result>
	</cfif>
	
	<cfloop from="1" to="#arrayLen(params)#" index="i">
		
		<cfset param = structNew()>
		
		<cftry>
			<cfset param.cfsqltype = params[i].getSqlTypeName()>
			<cfset param.value = params[i].getObject()>
			<cfset param.null = (not structKeyExists( param, "value" ))>
			<cfif param.null>
				<cfset param.value = "">
			</cfif>
		<cfcatch>	
			<cfset param.cfsqltype = "">
			<cfset param.value = "">
			<cfset param.null = false>
		</cfcatch>
		</cftry>
		
		<cfset result[i] = param>
	</cfloop>
	<cfreturn result>
</cffunction>

<cffunction name="SqlSetProperty" returntype="void" output="false">
	<cfargument name="sql" type="any" required="true">
	<cfargument name="property" type="string" required="true">
	<cfargument name="value" type="any" required="true">

	<cfif property eq "cachedWithin" or property eq "cachedAfter">
		<cfset sql.properties[property] = value>
	<cfelse>
		<cfset sql.objects.QueryTag[property] = value>
	</cfif>
</cffunction>